{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit maincopy;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Dialogs, EditBtn,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnCopy: TButton;
    cbDate: TCheckBox;
    edtCopyFrom: TFileNameEdit;
    lblCopyFrom: TLabel;
    lblCopyToFile: TLabel;
    procedure btnCopyClick(Sender: TObject);
    procedure edtCopyFromAcceptFileName(Sender: TObject; var Value: String);
  private
    SourceFileName: string;
    CopiedFileName: string;
    procedure CopyFile(sourceName, destinationName: string; copyDateToo: boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.edtCopyFromAcceptFileName(Sender: TObject; var Value: String);
var path, fName: string;
begin
  if (Value = EmptyStr) then Exit;
  path := ExtractFilePath(Value);
  fName:= ExtractFileName(Value);
  copiedFileName:= path + 'Copy of ' + fName;
   case FileExistsUTF8(copiedFileName) of
    False: begin
            lblCopyToFile.Caption := 'File will be copied to: '+ copiedFileName;
            btnCopy.Enabled:= True;
            SourceFileName:= Value;
           end;
    True : case QuestionDlg('Warning', copiedFileName + ' already exists'
                +sLineBreak+'Overwrite existing file?',mtWarning,
                [mrYes,'Overwrite file', mrNo,'Cancel file copy'],0) of
                mrYes: begin
                        lblCopyToFile.Caption := 'File will be copied to: '
                                                  + copiedFileName;
                        btnCopy.Enabled:= True;
                        SourceFileName:= Value;
                       end;
                else begin
                      Value:= EmptyStr;
                      btnCopy.Enabled:= False;
                      SourceFileName:= EmptyStr;
                      CopiedFileName:= EmptyStr;
                     end;
           end;
    end;
end;

procedure TForm1.btnCopyClick(Sender: TObject);
var append: string;
begin
  CopyFile(SourceFileName, CopiedFileName, cbDate.Checked);
  btnCopy.Enabled:=False;
  edtCopyFrom.Text:= EmptyStr;
  case cbDate.Checked of
   false: append := ' created with current date';
   true: append  := ' created with original date';
  end;
  lblCopyToFile.Caption:= CopiedFileName + append;
end;

procedure TForm1.CopyFile(sourceName, destinationName: string;
  copyDateToo: boolean);
var src: TFileStream = nil;
    dest: TFileStream = nil;
begin
  if SameText(sourceName, destinationName) then Exit;
  src := TFileStream.Create(UTF8ToSys(sourceName), fmOpenRead);
  try
    dest := TFileStream.Create(UTF8ToSys(destinationName), fmOpenWrite or fmCreate);
    try
      dest.CopyFrom(src, src.Size);
      if CopyDateToo
       then FileSetDate(dest.Handle, FileGetDate(src.Handle));
    finally
      dest.Free;
    end
  finally
   src.Free;
  end;
end;

end.

