{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit sListForm;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, StdCtrls;

const specimen: string = 'Enter by the narrow gate; for the wide gate has a '+
'broad road which leads to destruction and there are many people going that '+
'way. The narrow gate and the hard road lead to life and only a few find it.';
type

  { TForm1 }

  TForm1 = class(TForm)
    LBWords: TListBox;
    LCount: TLabel;
    MDisplay: TMemo;
    procedure FormCreate(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure TForm1.FormCreate(Sender: TObject);
var sl, noDuplicates: TStringList;
    j: integer;
begin
  MDisplay.Text:= specimen;
  sl := TStringList.Create;
  noDuplicates := TStringList.Create;
  try
   sl.CommaText:= specimen;
   sl.Sort;
   for j := 0 to sl.Count-1 do
     if (noDuplicates.IndexOf(sl[j]) < 0)
      then noDuplicates.Add(sl[j]);
   LBWords.Items.AddStrings(noDuplicates);
   LCount.Caption:= Format('Specimen text has %d words of which %d are unique',
                             [sl.Count, noDuplicates.Count]);
  finally
    sl.Free;
    noDuplicates.Free;
  end;
end;

end.

