{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

program windspeed;

{$mode objfpc}{$H+}

uses sysutils;

type TIntegerArray = array of integer;

  function WindSpeedArray(const aLine: string; var aDay: TDate):
                                                          TIntegerArray;
  begin
    // actual line parsing code should go here - instead we return dummy data
    aDay:=Now;
    SetLength(Result, 3);
    Result[0]:=25; Result[1]:= 23; Result[2]:=17;
  end;

  procedure DisplayAverageWindSpeed(anArray: TIntegerArray; aDay: TDate);
  var sum: integer=0;
      i, avg: integer;
  begin
    for i:= Low(anArray) to High(anArray) do
      Inc(sum, anArray[i]);
    avg:= sum div Length(anArray);
    writeln('Average wind speed for ',DateToStr(aDay),' is ',avg);
    SetLength(anArray, 0);
  end;

var windData: TextFile;
    d: TDate;
    s: string;
    wsa: TIntegerArray;
begin
  AssignFile(windData, 'wind_data.txt');
  Reset(windData);
  try
    while not EOF(windData) do
     begin
       ReadLn(windData, s);
       wsa:= WindSpeedArray(s, d);
       if Length(wsa) = 0 then
        raise Exception.CreateFmt('No data for %s: average cannot be'+
                                  ' computed', [DateToStr(d)])
        else DisplayAverageWindSpeed(wsa, d);
     end;
  finally
    CloseFile(windData);
  end;
  {$IFDEF WINDOWS}
  ReadLn;
  {$ENDIF}
end.
