{ Copyright (C) 2012 H Page-Clark

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA. }

unit drawing;

{$mode objfpc}{$H+}

interface

uses
  Classes, Controls, Graphics;

type

  { TDrawing }

  TDrawing = class(TGraphicControl)
  private
    FExtent: integer;
  public
    constructor Create(theOwner: TComponent; anExtent: integer);
    property Extent: integer read FExtent write FExtent;
  end;

  { TSquare }

  TSquare = class(TDrawing)
  public
   procedure Paint; override;
  end;

  { TCircle }

  TCircle = class(TDrawing)
  public
   procedure Paint; override;
  end;

implementation

{ TDrawing }

constructor TDrawing.Create(theOwner: TComponent; anExtent: integer);
begin
  inherited Create(theOwner);
  FExtent:= anExtent;
  Width:= FExtent;
  Height:= FExtent;
end;

{ TCircle }

procedure TCircle.Paint;
begin
  Canvas.Brush.Color := clBtnFace;
  Canvas.FillRect(0, 0, FExtent, FExtent);
  Canvas.Brush.Color := clYellow;
  Canvas.Ellipse(0, 0, FExtent, FExtent);
end;

{ TSquare }

procedure TSquare.Paint;
begin
  Canvas.Brush.Color := clSilver;
  Canvas.FillRect(0, 0, FExtent, FExtent);
  Canvas.Rectangle(0, 0, FExtent, FExtent);
end;

end.

